<script setup lang="ts">
  import { useVuelidate } from '@vuelidate/core';
  import { required, minLength, requiredIf } from '@vuelidate/validators';
  import { ListboxLabel } from '@headlessui/vue';
  import { CustomerAddress } from '@shopware-pwa/types';

  defineEmits(['update:address']);

  const props = defineProps<{
    address?: CustomerAddress;
    errors?: any[];
  }>();

  const state = reactive({
    firstName: '',
    lastName: '',
    street: '',
    zipcode: '',
    city: '',
    countryId: '',
    countryStateId: '',
  });

  watch(
    () => props.address,
    (addressValue) => {
      if (!addressValue) {
        return;
      }
      state.firstName = addressValue.firstName;
      state.lastName = addressValue.lastName;
      state.street = addressValue.street;
      state.zipcode = addressValue.zipcode;
      state.city = addressValue.city;
      state.countryId = addressValue.countryId;
      state.countryStateId = addressValue.countryStateId || '';
    },
    { immediate: true },
  );

  const { getCountries, getStatesForCountry } = useCountries();

  const isCountryHasStates = computed(() => {
    const states = getStatesForCountry(state.countryId) || [];
    return states.length > 0;
  });

  const rules = computed(() => ({
    firstName: {
      required,
    },
    lastName: {
      required,
    },
    street: {
      required,
      minLength: minLength(3),
    },
    zipcode: {
      required,
    },
    city: {
      required,
    },
    countryId: {
      required,
    },
    countryStateId: {
      required: requiredIf(() => {
        return isCountryHasStates.value;
      }),
    },
  }));

  const $v = useVuelidate(rules, state);

  const validate = () => {
    $v.value.$touch();
    return $v.value.$validate();
  };

  defineExpose({ state, validate });
</script>

<template>
  <div class="flex flex-col space-y-6">
    <div class="md:(flex-row space-y-0) flex flex-col space-y-6 md:space-x-6">
      <SwTextField
        id="first-name"
        v-model="state.firstName"
        :placeholder="$t('createAccountForm.firstNamePlaceholder')"
        name="first-name"
        type="text"
        size="large"
        class="flex-1"
        :errors="$v.firstName.$errors"
        :label="$t('firstName')"
        @blur="$v.firstName.$touch"
      />
      <SwTextField
        id="last-name"
        v-model="state.lastName"
        :placeholder="$t('createAccountForm.lastNamePlaceholder')"
        name="last-name"
        type="text"
        size="large"
        class="flex-1"
        :errors="$v.lastName.$errors"
        :label="$t('lastName')"
        @blur="$v.lastName.$touch"
      />
    </div>
    <div>
      <SwTextField
        id="street-address"
        v-model="state.street"
        :placeholder="$t('createAccountForm.streetAndNumberPlaceholder')"
        name="street-address"
        type="text"
        size="large"
        :errors="$v.street.$errors"
        :label="$t('streetAndNumber')"
        @blur="$v.street.$touch"
      />
    </div>
    <div class="md:(flex-row space-y-0) flex flex-col space-y-6 md:space-x-6">
      <SwTextField
        id="postal-code"
        v-model="state.zipcode"
        :placeholder="$t('createAccountForm.zipcodePlaceholder')"
        name="postal-code"
        type="text"
        size="large"
        class="flex-1"
        :errors="$v.zipcode.$errors"
        :label="$t('postalCode')"
        @blur="$v.zipcode.$touch"
      />
      <SwTextField
        id="city"
        v-model="state.city"
        :placeholder="$t('createAccountForm.accountCityPlaceholder')"
        name="city"
        type="text"
        size="large"
        class="flex-1"
        :errors="$v.city.$errors"
        :label="$t('city')"
        @blur="$v.city.$touch"
      />
    </div>
    <div class="md:(flex-row space-y-0) flex flex-col space-y-6 md:space-x-6">
      <SwSelect
        v-model="state.countryId"
        key-field="id"
        label-field="name"
        :options="getCountries"
        :errors="$v.countryId.$errors"
        size="large"
        class="flex-1"
        :placeholder="$t('createAccountForm.chooseCountry')"
        @update:model-value="() => (state.countryStateId = '')"
      >
        <template #label>
          <ListboxLabel class="text-(sm/6 information-dark) mb-1.5 block font-medium">
            {{ $t('country') }}
          </ListboxLabel>
        </template>
      </SwSelect>
      <SwSelect
        v-if="isCountryHasStates"
        v-model="state.countryStateId"
        key-field="id"
        label-field="name"
        :options="getStatesForCountry(state.countryId)"
        :errors="$v.countryStateId.$errors"
        size="large"
        class="flex-1"
        :placeholder="$t('createAccountForm.countryStatePlaceholder')"
      >
        <template #label>
          <ListboxLabel class="text-(sm/6 information-dark) mb-1.5 block font-medium">
            {{ $t('state') }}
          </ListboxLabel>
        </template>
      </SwSelect>
      <div v-else class="hidden flex-1 md:block"></div>
    </div>
  </div>
</template>
